angular.module('starter.controllers', [])



        .controller('AppCtrl', ['$scope', '$rootScope', '$ionicModal', '$timeout', 'AuthenticationService', '$state', '$ionicPopup', '$localStorage', '$ionicLoading', '$voip', 'ApiService', '$cordovaFileOpener2',
            function ($scope, $rootScope, $ionicModal, $timeout, AuthenticationService, $state, $ionicPopup, $localStorage, $ionicLoading, $voip, ApiService, $cordovaFileOpener2) {

                $scope.labels = [];
                $scope.series = ['Voz', 'Datos'];
                $scope.consumodata = [[], []];

                $scope.loginModal = null;
                $scope.loginData = {
                    username: "",
                    password: ""
                };

                $scope.openDial = function (param) {
                    //console.log(param)
                    //var ref=window.open('tel:66666666', '_system','location=yes');		
                    return false;
                }

                $scope.impersonateData = {
                    username: "",
                    password: "",
                    impersonate: ""
                };

                $scope.resetData = {
                    username: ""
                }

                $scope.suscriptionModal = null;

                // Create the login modal that we will use later
                $ionicModal.fromTemplateUrl('templates/login.html', {
                    scope: $scope
                }).then(function (modal) {
                    $scope.loginModal = modal;
                    //$scope.login();
                });

                $ionicModal.fromTemplateUrl('templates/selector-lineas.html', {
                    scope: $scope
                }).then(function (modal) {
                    $scope.suscriptionModal = modal;
                });

                $scope.verConsumo = function (subscription)
                {
                    $scope.globals.currentLine = subscription;

                }

                $scope.abrirFactura = function (mesfactura, accountId)
                {


                    var parts = mesfactura.match(/[\s\S]{1,4}/g) || [];

                    if (window.cordova) {

                        $ionicLoading.show({
                            template: 'Descargando factura'
                        });

                        ApiService.getFactura(parts[0], parts[1], accountId).then(function (result) {

                            $cordovaFileOpener2.open(
                                    result.nativeURL,
                                    'application/pdf'
                                    ).then(function () {

                            }, function (err) {
                                $scope.showAlert(
                                        'Error al abrir factura',
                                        "No hemos podido abrir el contrato."
                                        );
                            });
                            setTimeout(function () {
                                $ionicLoading.hide();
                            }, 100);
                        }, function (err) {
                            setTimeout(function () {
                                $ionicLoading.hide();
                            }, 100);
                            $scope.showAlert(
                                    'Error al descargar factura',
                                    "No hemos podido servir tu factura."
                                    );
                        }, function (progress) {

                            $scope.downloadProgress = (progress.loaded / progress.total) * 100;

                        });
                    } else {

                        url = ApiService.getFacturaUrl(parts[0], parts[1], accountId);
                        window.open(url, '_blank');
                    }
                }

                $scope.tienePrepago = function () {
                    var prepayment = false;

                    if (typeof ($rootScope.userdata) !== "undefined") {
                        for (var key in $rootScope.userdata.lines) {
                            if ($rootScope.userdata.lines[key].line && $rootScope.userdata.lines[key].line.tipo == "pre")
                                prepayment = true;
                        }
                    }


                    return prepayment;

                };

                $scope.tieneLineas = function () {
                    var tieneLineas = true;

                    if (typeof ($rootScope.userdata) !== "undefined" && $rootScope.userdata.lines.length == 0) {
                        tieneLineas = false;
                    }



                    return tieneLineas;

                };

                $scope.isMobile = function () {

                    if (window.cordova)
                        return true;
                    else
                        return false;
                };

                $scope.showAlert = function (title, template, callback) {

                    var alertPopup = $ionicPopup.alert({
                        title: title,
                        template: template
                    });

                    alertPopup.then(
                            function ()
                            {
                                if (typeof callback != 'undefined')
                                    callback();
                            }
                    );
                };

                // Triggered in the login modal to close it
                $scope.closeLogin = function () {
                    $scope.loginModal.hide();
                };

                $scope.closeSuscriptions = function (suscription) {
                    $scope.suscriptionModal.hide();
                    $scope.globals.currentLine = suscription;

                    /*if($scope.globals.currentLine in $scope.globals.voipLines)
                     $scope.globals.hasVoip = true;
                     else
                     $scope.globals.hasVoip = false;*/


                    $scope.$broadcast('changeLine');
                };


                $scope.updateHistoricoConsumo = function () {

                    $scope.mostrarHistorico = false;

                    if (typeof ($rootScope.consumo[$scope.globals.currentLine].historico) !== 'undefined') {

                        $scope.currentHistorico = $rootScope.consumo[$scope.globals.currentLine].historico;

                        if ($rootScope.sizeOf($scope.currentHistorico.voz) == 0 && $rootScope.sizeOf($scope.currentHistorico.datos) == 0)
                            $scope.mostrarHistorico = false;
                        else {
                            var datavoz = [[]];
                            var datadatos = [[]];
                            var labels = [];
                            var labelsDatos = [];

                            var i = 0;
                            for (key in $scope.currentHistorico.voz) {

                                mes = $scope.currentHistorico.voz[key];
                                labels.push(mes.mes_string)
                                datavoz[0][i] = mes.minutos;
                                i++;
                            }

                            var i = 0;
                            for (key in $scope.currentHistorico.datos) {

                                mes = $scope.currentHistorico.datos[key];
                                labelsDatos.push(mes.mes_string)
                                datadatos[0][i] = Math.round(mes.Mb_consum);
                                i++;
                            }

                            $scope.colours = ['#7fbfb5', '7fbfb5'];
                            $scope.consumodatavoz = datavoz;
                            $scope.consumodatadatos = datadatos;
                            $scope.labelsvoz = labels;
                            $scope.labelsdatos = labelsDatos;
                            $scope.mostrarHistorico = true;
                        }
                    } else {
                        $scope.mostrarHistorico = false;
                    }

                };

                $scope.updateConsumo = function () {

                    ApiService.getConsumoLinea($scope.globals.currentLine).then(
                            function (response)
                            {

                                $scope.updateHistoricoConsumo();

                                $ionicLoading.hide();
                            },
                            function (err)
                            {

                                $scope.showAlert(
                                        'Ha ocurrido un error',
                                        "No hemos podido encontrar tus datos de consumo."
                                        );

                                $ionicLoading.hide();


                            }
                    );


                };

                // Open the login modal
                $scope.login = function () {
                    $scope.loginModal.show();
                };

                $scope.selectSuscription = function () {
                    $scope.suscriptionModal.show();
                };

                // Perform the login action when the user submits the login form
                $scope.doLogin = function () {
                    // $scope.dataLoading = true;
                    $ionicLoading.show({
                        template: 'Autenticando'
                    });

                    AuthenticationService.Login($scope.loginData.username, $scope.loginData.password, function (response) {

                        if (response) {
                            $scope.closeLogin();
                            $ionicLoading.hide();

                            setTimeout(function () {
                                $state.go('app.welcome', {}, {reload: true});
                            }, 300);

                        } else {
                            setTimeout(function () {
                                $ionicLoading.hide();
                            }, 300);
                            $scope.showAlert(
                                    'Error de autenticación',
                                    "Comprueba tus datos de acceso."
                                    );
                        }
                    });
                };

                // Perform the login action when the user submits the login form
                $scope.resetPassword = function () {
                    // $scope.dataLoading = true;
                    $ionicLoading.show({
                        template: 'Solicitando nueva contraseña'
                    });

                    AuthenticationService.ResetPassword($scope.resetData.username, function (response) {

                        if (response.result) {
                            $scope.showAlert(
                                    'Comprueba tu email',
                                    "Te ha llegado un correo electrónico con las instrucciones para cambiar tu contraseña"
                                    );

                        } else {
                            setTimeout(function () {
                                $ionicLoading.hide();
                            }, 300);
                            $scope.showAlert(
                                    'Ha ocurrido un error',
                                    response.data.message
                                    );
                        }

                        $ionicLoading.hide();
                    });
                };

                // Perform the login action when the user submits the login form
                $scope.impersonate = function () {
                    // $scope.dataLoading = true;
                    $ionicLoading.show({
                        template: 'Autenticando'
                    });

                    AuthenticationService.Impersonate($scope.impersonateData.username, $scope.impersonateData.password, $scope.impersonateData.impersonate, function (response) {

                        if (response) {
                            $scope.closeLogin();
                            $ionicLoading.hide();
                            $state.go('app.welcome', {}, {reload: true});
                        } else {

                            $scope.showAlert(
                                    'Error de autenticación',
                                    "Comprueba tus datos de acceso."
                                    );
                            setTimeout(function () {
                                $ionicLoading.hide();
                            }, 300);
                        }
                    });
                };

                $scope.salir = function () {
                    $localStorage.remove('isLogged');
                    $localStorage.remove('username');
                    $localStorage.remove('apikey');
                    $state.go('home');
                };

                $scope.range = function (min, max, step) {
                    step = step || 1;
                    var input = [];

                    if (min > max)
                        return input;

                    for (var i = min; i <= max; i += step)
                        input.push(i);

                    return input;
                };

                $scope.objectLength = function (elem) {
                    var keys = [];

                    for (var k in elem)
                        keys.push(k);

                    return keys.length;
                }
            }])

        .controller('HomeCtrl', function ($scope, $stateParams) {




        })
        .controller('WelcomeCtrl', function ($scope, $stateParams, ApiService, $rootScope) {
            $scope.apiService = ApiService;

            $rootScope.consumo[$scope.globals.currentLine] = {finalizado: false};

            $scope.apiService.getConsumoLinea($scope.globals.currentLine).then(
                    function (response)
                    {
                        //$rootScope.consumo[$scope.globals.currentLine].finalizado = true;

                    },
                    function (err)
                    {

                    });

            $scope.nombreTarifa = function (bonos) {
                if (!bonos)
                    return "cero";

                var tarifa = "";
                if (!bonos.voz && !bonos.datos)
                    return "cero"

                if (bonos.datos) {
                    tarifa = tarifa + bonos.datos.invoice_literal;

                } else
                    tarifa = "cero"


                if (bonos.voz)
                    tarifa = tarifa + " " + bonos.voz.invoice_literal;

                if (bonos.throttle) {
                    tarifa = tarifa + " " + bonos.throttle.invoice_literal;
                }

                return tarifa;

            }



        })
        .controller('ConsumoCtrl', function ($scope, $rootScope, $stateParams, ApiService, $ionicLoading, $ionicPopup) {
            $scope.finish = false;
            $scope.estado = "consumo";


            $scope.consumoEstado = function (estado) {
                $scope.estado = estado;

            }

            $scope.translateEstado = function (estado) {
                if ($scope.estado == "consumo")
                    return "resumen de consumo"
                if ($scope.estado == "cdr-voz")
                    return "detalle de consumo de voz"
                if ($scope.estado == "cdr-dat")
                    return "detalle de consumo de datos"
                if ($scope.estado == "cdr-oth")
                    return "detalle de otros consumos"

            }

            $scope.$on('changeLine', function (e) {
                $scope.estado = "consumo";
                $scope.cargarConsumo();
            });


            $scope.totalConsumo = function (consumos) {

                total = 0;

                var tax = 1.21;

                if ($rootScope.userdata.client.tax)
                    tax = $rootScope.userdata.client.tax;


                total = parseFloat(consumos.cuota) * tax;


                if (consumos.consumo.aplicarimpuesto) {

                    total = total + parseFloat(Math.round(((consumos.consumo.internet) * tax) * 100) / 100);
                    total = total + parseFloat(Math.round(((consumos.consumo.voz) * tax) * 100) / 100);
                    total = total + parseFloat(Math.round(((consumos.consumo.otros) * tax) * 100) / 100);
                    total = total.toFixed(2);


                } else {
                    total = total + parseFloat(consumos.consumo.internet);
                    total = total + parseFloat(consumos.consumo.voz);
                    total = total + parseFloat(consumos.consumo.otros);
                    if (consumos.consumo.extra)
                        total = total + parseFloat(Math.round(((consumos.consumo.extra) * tax) * 100) / 100);


                    total = total.toFixed(2);
                }

                return total;

            }

            $scope.cargarConsumo = function () {
                // si el consumo no está cargado
                if (!$rootScope.consumo[$scope.globals.currentLine]) {

                    $rootScope.consumo[$scope.globals.currentLine] = {finalizado: false};
                    $scope.apiService.getConsumoLinea($scope.globals.currentLine).then(
                            function (response)
                            {

                                $rootScope.consumo[$scope.globals.currentLine].finalizado = true;

                                $scope.updateHistoricoConsumo();


                            },
                            function (err)
                            {

                                $scope.showAlert(
                                        'Ha ocurrido un error',
                                        "No hemos podido encontrar tus datos de consumo."
                                        );

                                $ionicLoading.hide();


                            }
                    );
                } else {
                    // $rootScope.consumo[$scope.globals.currentLine].finalizado = true;
                    $scope.updateHistoricoConsumo();
                }

            }

            $scope.confirmarDatosExtra = function () {
                if ($rootScope.userdata.lines[$scope.globals.currentLine].line.tipo == 'pre' && $rootScope.userdata.lines[$scope.globals.currentLine].line.saldo < 4) {

                    $scope.showAlert(
                            'Lo sentimos',
                            "No tienes saldo suficiente para contratar un bono extra"
                            );

                } else {

                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Contratar datos extra',
                        template: '<p>Puedes contratar un bono extra de 500MB por 4€ más al mes</p><p>¿Quieres contratar este bono?</p>'
                    });

                    confirmPopup.then(function (res) {
                        if (res) {
                            $ionicLoading.show({
                                template: 'Solicitando bono extra'
                            });

                            $scope.apiService.contractBono($scope.globals.currentLine).then(
                                    function (response)
                                    {

                                        $ionicLoading.hide();
                                        $scope.showAlert(
                                                'Solicitud de bono extra',
                                                "La solicitud de bono se ha realizado correctamente"
                                                );

                                    },
                                    function (err)
                                    {

                                        setTimeout(function () {
                                            $ionicLoading.hide();
                                        }, 100);

                                        if (err.status != 403) {
                                            $scope.showAlert(
                                                    'Error solicitando bono extra',
                                                    "Ha ocurrido un error al intentar solicitar un bono extra de datos"
                                                    );
                                        }
                                    }
                            );
                        }
                    });
                }
            };


            $scope.nombreTarifa = function (bonos) {
                if (!bonos)
                    return "cero";

                var tarifa = "";
                if (!bonos.voz && !bonos.datos)
                    return "cero"

                if (bonos.datos) {
                    tarifa = tarifa + bonos.datos.invoice_literal;

                } else
                    tarifa = "cero"


                if (bonos.voz)
                    tarifa = tarifa + " " + bonos.voz.invoice_literal;

                if (bonos.throttle) {
                    tarifa = tarifa + " " + bonos.throttle.invoice_literal;
                }

                return tarifa;

            }

            $scope.redondearInternet = function (valor) {
                megas = valor;

                if (valor < 1024) {
                    megas = Math.round(megas);
                    return megas + " MB";
                } else {
                    var megas = Math.round(megas / 1024 * 10) / 10;
                    return megas + " GB";
                }


            }

            $scope.apiService = ApiService;
            $scope.cargarConsumo();

        })

        .controller('ServiciosCtrl', function ($scope, $stateParams, $ionicModal, $ionicPopup, $ionicLoading, ApiService, $voip) {
            $scope.apiService = ApiService;

            $scope.modal = null;
            $scope.data = {roaming: true, bloqueo: false};

            if (window.cordova) {
                $voip.check().then(function (number) {
                    if (number == $scope.globals.currentLine)
                        $scope.data.hasVoip = true;
                }
                , console.log
                        );
            }



            $scope.doClose = function ()
            {
                if ($scope.modal != null)
                {



                    $scope.modal.hide();
                    $scope.modal = null;
                }
            };

            $scope.modalPorNombre = function (nombre)
            {
                $ionicModal.fromTemplateUrl('templates/modales-servicios/' + nombre + '.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function (modal) {
                    $scope.modal = modal;
                    $scope.modal.show();
                });
            };

            $scope.confirmReemplazo = function () {
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Solicitar reemplazo',
                    template: 'Estás seguro de que deseas solicitar un reemplazo de tarjeta SIM '
                });

                confirmPopup.then(function (res) {
                    if (res) {
                        $ionicLoading.show({
                            template: 'Solicitando reemplazo'
                        });

                        $scope.apiService.changeService($scope.globals.currentLine, 'REPLACE', 'REPLACE').then(
                                function (response)
                                {

                                    $ionicLoading.hide();
                                    $scope.showAlert(
                                            'Solicitud de reemplazo',
                                            "La solicitud de reemplazo ha sido realizada correctamente"
                                            );

                                },
                                function (err)
                                {

                                    setTimeout(function () {
                                        $ionicLoading.hide();
                                    }, 100);

                                    if (err.status != 403) {
                                        $scope.showAlert(
                                                'Error solicitando reemplazo',
                                                "Ha ocurrido un error al intentar solicitar un reemplazo"
                                                );
                                    }
                                }
                        );
                    }
                });
            };

            $scope.confirmRoaming = function (roaming) {

                if (roaming)
                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Solicitar roaming',
                        template: 'Estás seguro de que deseas solicitar el servicio de roaming'
                    });
                else
                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Desactivar roaming',
                        template: 'Estás seguro de que deseas desactivar el servicio de roaming'
                    });

                confirmPopup.then(function (res) {

                    if (res) {
                        if (roaming)
                            var action = "ENABLED";
                        else
                            var action = "DISABLED";

                        if (res) {
                            $ionicLoading.show({
                                template: 'Solicitando cambio de servicio'
                            });

                            $scope.apiService.changeService($scope.globals.currentLine, 'ROAMING', action).then(
                                    function (response)
                                    {

                                        $ionicLoading.hide();
                                        $scope.showAlert(
                                                'Solicitud de roaming',
                                                "La solicitud de roaming ha sido realizada correctamente"
                                                );

                                    },
                                    function (err)
                                    {

                                        setTimeout(function () {
                                            $ionicLoading.hide();
                                        }, 100);

                                        if (err.status != 403) {
                                            $scope.showAlert(
                                                    'Error solicitando cambio de roaming',
                                                    "Ha ocurrido un error al intentar solicitar un cambio de roaming"
                                                    );
                                        }
                                    }
                            );
                        }
                    }

                });

            };

            $scope.confirmBloqueo = function () {


                var confirmPopup = $ionicPopup.confirm({
                    title: 'Solicitar bloqueo',
                    template: 'Estás seguro de que deseas activar el bloqueo de linea'});


                confirmPopup.then(function (res) {

                    if (!res) {
                        $scope.data.bloqueo = !$scope.data.bloqueo;
                    } else {

                        if ($scope.data.bloqueo)
                            var action = "ENABLED";
                        else
                            var action = "DISABLED";

                        $scope.apiService.changeService($scope.globals.currentLine, 'BLOCK_LINE', action).then(
                                function (response)
                                {

                                    $ionicLoading.hide();
                                    $scope.showAlert(
                                            'Solicitud de bloqueo',
                                            "La solicitud de bloqueo ha sido realizada correctamente"
                                            );

                                },
                                function (err)
                                {

                                    setTimeout(function () {
                                        $ionicLoading.hide();
                                    }, 100);
                                    $scope.data.bloqueo = !$scope.data.bloqueo;
                                    if (err.status != 403) {
                                        $scope.showAlert(
                                                'Error solicitando bloqueo de linea',
                                                "Ha ocurrido un error al intentar solicitar un bloqueo de linea"
                                                );
                                    }
                                }
                        );
                    }

                });

            };

            $scope.confirmVoip = function () {
                if ($scope.globals.hasVoip)
                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Solicitar Voip',
                        template: 'Estás seguro de que deseas solicitar el servicio de voip'
                    });
                else
                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Desactivar voip',
                        template: 'Estás seguro de que deseas desactivar el servicio de voip'
                    });

                confirmPopup.then(function (res) {
                    if (res) {
                        if ($scope.globals.hasVoip) {
                            $voip.activate_line($scope.globals.currentLine).then(
                                    function (data) {
                                        if (data['error']) {
                                            showAlert(data['error']);
                                            $scope.data.hasVoip = true;
                                        }
                                        else {
                                            $scope.data.hasVoip = true;
                                        }


                                    },
                                    console.log
                                    );
                        } else {
                            $voip.deactivate($scope.globals.currentLine).then(
                                    function (data) {
                                        $rootScope.getVoipData();
                                    },
                                    console.log
                                    );
                        }
                    }
                });
            }
        })


        .controller('DatosCtrl', function ($scope, $rootScope, $stateParams, ApiService, $cordovaFileOpener2, $state) {
            $scope.apiService = ApiService;

            $scope.abrirContrato = function (msisdn)
            {
                if (window.cordova) {
                    $scope.apiService.getContrato(msisdn).then(function (result) {
                        $cordovaFileOpener2.open(
                                result.nativeURL,
                                'application/pdf'
                                ).then(function () {

                        }, function (err) {
                            $scope.showAlert(
                                    'Error al abrir contrato',
                                    "No hemos podido abrir el contrato."
                                    );
                        });
                    }, function (err) {
                        $scope.showAlert(
                                'Error al descargar contrato',
                                "No hemos podido servir el contrato."
                                );
                    }, function (progress) {

                        $scope.downloadProgress = (progress.loaded / progress.total) * 100;

                    });
                } else {
                    url = $scope.apiService.getContratoUrl(msisdn);
                    window.open(url, '_blank');
                }
            }

            $scope.seleccionarCuenta = function (cuenta) {


                $rootScope.cuenta = {
                    cuenta: cuenta.cuenta,
                    titular: cuenta.titular,
                    identityValue: cuenta.documentnumber,
                    identityType: cuenta.document_type_name
                }

                $state.go('app.datos-bancarios');


            }



        })

        .controller('DatosBancariosCtrl', function ($scope, $stateParams, ApiService, $state, $ionicPopup, $ionicLoading) {
            $scope.apiService = ApiService;

            $scope.bankData = {
                titular: $scope.cuenta.titular,
                cuenta: '',
                identityValue: $scope.cuenta.identityValue,
                identityType: $scope.cuenta.identityType
            }

            $scope.cambiarCuenta = function () {

                var confirmPopup = $ionicPopup.confirm({
                    title: 'Cambio de cuenta bancaria',
                    template: '¿Estás seguro de que deseas solicitar un cambio de cuenta bancaria?'
                });

                confirmPopup.then(function (res) {

                    if (res) {
                        $ionicLoading.show({
                            template: 'Enviando información'
                        });

                        $scope.apiService.changeBankAccount($scope.bankData).then(
                                function (response)
                                {

                                    $ionicLoading.hide();
                                    $scope.showAlert(
                                            'Tu solicitud ha sido realizada con éxito',
                                            "Tu solicitud será gestionada muy pronto"
                                            );

                                },
                                function (err)
                                {

                                    setTimeout(function () {
                                        $ionicLoading.hide();
                                    }, 100);

                                    if (err.status != 403) {
                                        $scope.showAlert(
                                                'Error solicitando cambio de cuenta bancaria',
                                                "Ha ocurrido un error al contactar con el servidor"
                                                );
                                    }
                                }
                        );
                    }
                });


            }


        })

        .controller('DatosAccesoCtrl', function ($scope, $stateParams, $ionicPopup, $ionicLoading, $timeout, ApiService) {
            $scope.apiService = ApiService;
            $scope.passwordData = {
                password: "",
                newPassword: ""
            }

            $scope.editarDatos = function () {
                valid = false;

                if ($scope.passwordData.password == $scope.passwordData.newPassword) {


                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Cambio de contraseña',
                        template: '¿Estás seguro de que deseas cambiar tu contraseña?'
                    });

                    confirmPopup.then(function (res) {

                        if (res) {
                            $ionicLoading.show({
                                template: 'Enviando información'
                            });

                            $scope.apiService.changePassword($scope.passwordData.password).then(
                                    function (response)
                                    {

                                        $ionicLoading.hide();
                                        $scope.showAlert(
                                                'Contraseña cambiada con éxito',
                                                "La proxima vez recuerda autenticarte con tu nueva contraseña."
                                                );

                                    },
                                    function (err)
                                    {

                                        setTimeout(function () {
                                            $ionicLoading.hide();
                                        }, 100);

                                        if (err.status != 403) {
                                            $scope.showAlert(
                                                    'Error cambio password',
                                                    "Ha ocurrido un error al contactar con el servidor"
                                                    );
                                        }
                                    }
                            );
                        }
                    });


                } else {
                    $scope.showAlert(
                            'Error de validación',
                            "Las contraseñas deben coincidir"
                            );
                }

            }

        })

        .controller('DatosContactoCtrl', function ($scope, $rootScope, $stateParams, $ionicPopup, $ionicLoading, $timeout, ApiService) {

            $scope.apiService = ApiService;
            name = $rootScope.userdata.client.name + " " + $rootScope.userdata.client.middle_name + " " + $rootScope.userdata.client.last_name
            name = name.toLowerCase();
            $scope.contactData = {
                'name': name,
                'email': $rootScope.userdata.client.email,
                'phone': $rootScope.userdata.client.otherphone,
            };

            $scope.editarDatos = function () {


                var confirmPopup = $ionicPopup.confirm({
                    title: 'Cambio de datos',
                    template: '¿Estás seguro de que deseas cambiar los datos de contacto?'
                });

                confirmPopup.then(function (res) {

                    if (res) {

                        $ionicLoading.show({
                            template: 'Enviando información'
                        });

                        $scope.apiService.changeContactData($scope.contactData).then(
                                function (response)
                                {

                                    $ionicLoading.hide();
                                    $scope.showAlert(
                                            'Solicitud enviada correctamente',
                                            "Tu petición será procesada en 24/48H"
                                            );

                                },
                                function (err)
                                {

                                    setTimeout(function () {
                                        $ionicLoading.hide();
                                    }, 100);

                                    if (err.status != 403) {
                                        $scope.showAlert(
                                                'Error al solicitar cambio de datos',
                                                "Ha ocurrido un error al contactar con el servidor"
                                                );
                                    }
                                }
                        );




                    }
                    ;

                });

            }
        })

        .controller('DatosPersonalesCtrl', function ($scope, $rootScope, $stateParams, $ionicPopup, $ionicLoading, $timeout, ApiService) {
            $scope.apiService = ApiService;
            $scope.apiService.getNacionalidades();
            $scope.apiService.getProvincias();
            var name = $rootScope.userdata.client.name + " " + $rootScope.userdata.client.middle_name + " " + $rootScope.userdata.client.last_name;
            name = name.toLowerCase();
            $scope.personalData = {
                'firstName': name,
                'email': $rootScope.userdata.client.email,
                'identityType': $rootScope.userdata.client.document_type_name,
                'identityValue': $rootScope.userdata.client.documentnumber,
                'birthday': new Date($rootScope.userdata.client.birthdate),
                'nationality': {'id': $rootScope.userdata.client.nationality_id.toString(), 'mm_id': $rootScope.userdata.client.nationality_id_mm.toString(), 'name': $rootScope.userdata.client.nationality},
                'streetName': $rootScope.userdata.client.street,
                'postcode': $rootScope.userdata.client.zip,
                'locality': $rootScope.userdata.client.locality,
                'postalTown': {'id': $rootScope.userdata.client.state_id.toString(), 'mm_state_id': $rootScope.userdata.client.state_id_mm.toString(), 'nombre': $rootScope.userdata.client.state_name},
            };

            console.log($scope.personalData);

            $scope.editarDatos = function () {


                var confirmPopup = $ionicPopup.confirm({
                    title: 'Cambio de datos',
                    template: '<p>¿Estás seguro de que deseas cambiar tus datos personales?</p> '
                });

                confirmPopup.then(function (res) {

                    if (res) {

                        $ionicLoading.show({
                            template: 'Enviando información'
                        });

                        $scope.apiService.changePersonalData($scope.personalData).then(
                                function (response)
                                {

                                    $ionicLoading.hide();
                                    $scope.showAlert(
                                            'Solicitud enviada correctamente',
                                            "Tu petición será procesada en 24/48H"
                                            );

                                },
                                function (err)
                                {

                                    setTimeout(function () {
                                        $ionicLoading.hide();
                                    }, 100);

                                    if (err.status != 403) {
                                        $scope.showAlert(
                                                'Error al solicitar cambio de datos',
                                                "Ha ocurrido un error al contactar con el servidor"
                                                );
                                    }
                                }
                        );




                    }
                    ;

                });

            }
        })


        .controller('TarifaCtrl', function ($scope, $rootScope, $stateParams, ApiService, $ionicPopup, $ionicLoading, $filter, $ionicScrollDelegate, $location, $state) {
            $scope.apiService = ApiService;

            $scope.actualizarTarifa = function () {
                var currentLine;

                //existe la linea
                if ($rootScope.userdata.lines[$scope.globals.currentLine].line) {
                    var bonos = $rootScope.userdata.lines[$scope.globals.currentLine].line.bonos;

                    if (bonos.datos) {
                        datos = $scope.getTarifaDatosByWebLiteral(bonos.datos.invoice_literal);
                    } else {
                        datos = $scope.getTarifaDatosByWebLiteral(false);
                    }

                    if (bonos.voz) {
                        voz = $scope.getTarifaVozByWebLiteral(bonos.voz.invoice_literal);
                    } else {
                        voz = $scope.getTarifaVozByWebLiteral(false);
                    }



                    $scope.cambioTarifa = {
                        'voz': voz,
                        'datos': datos,
                        'throttle': bonos.throttle ? true : false

                    }
                }

            }

            $scope.recargar = function () {
                $state.go('app.recargas', {}, {reload: true});
            }



            $scope.updateSolicitudesProgramados = function () {
                $scope.solicitudCambio = false;
                $scope.programados = false;
                $scope.apiService.detalleTarifa($scope.globals.currentLine).then(function (res) {
                    $scope.solicitudCambio = res.data.cambioTarifa;
                    $scope.programados = res.data.programados;
                });
            }

            $scope.apiService.getBonos().then(function (res) {
                $scope.actualizarTarifa();
            });

            $scope.updateSolicitudesProgramados();


            $scope.redondearInternet = function (valor) {
                megas = valor;

                if (valor < 1024) {
                    megas = Math.round(megas);
                    return megas + " MB";
                } else {
                    var megas = Math.round(megas / 1024 * 10) / 10;
                    return megas + " GB";
                }


            }

            $scope.nombreActualTarifa = function (bonos) {
                if (!bonos)
                    return "cero";

                var tarifa = "";
                if (!bonos.voz && !bonos.datos)
                    return "cero"

                if (bonos.datos) {
                    tarifa = tarifa + bonos.datos.invoice_literal;

                } else
                    tarifa = "cero"


                if (bonos.voz)
                    tarifa = tarifa + " " + bonos.voz.invoice_literal;

                if (bonos.throttle) {
                    tarifa = tarifa + " " + bonos.throttle.invoice_literal;
                }

                return tarifa;

            }

            $scope.scrollBottom = function () {
                $ionicScrollDelegate.scrollBottom(true);
            }

            $scope.scrollTo = function (to) {

                $location.hash(to);
                $ionicScrollDelegate.anchorScroll(true);
            }

            $scope.cambioTarifa = {
                'voz': 'cero',
                'datos': 'cero',
                'throttle': false,
                'voip': false,
            }



            $scope.$on('changeLine', function (e) {
                $scope.actualizarTarifa();
                $scope.updateSolicitudesProgramados();
            });

            $scope.nombreTarifa = function () {

                var nombreTarifa = "";
                if ($scope.cambioTarifa.datos.invoice_literal != "cero")
                    nombreTarifa = $scope.cambioTarifa.datos.invoice_literal;
                else
                    nombreTarifa = "cero";

                if ($scope.cambioTarifa.voz.invoice_literal != "cero")
                    nombreTarifa += " " + $scope.cambioTarifa.voz.invoice_literal;

                if ($scope.cambioTarifa.throttle)
                    nombreTarifa += " " + "plus";

                return nombreTarifa;

            }



            $scope.precioTarifa = function () {
                var precio = 0;
                var nombreTarifa = "";
                if ($scope.cambioTarifa.datos.invoice_literal != "cero")
                    precio += $scope.cambioTarifa.datos.price;

                if ($scope.cambioTarifa.voz.invoice_literal != "cero")
                    precio += $scope.cambioTarifa.voz.price;

                if ($scope.cambioTarifa.throttle)
                    precio += 79;

                precio = precio / 100;

                precio = $filter('tax')(precio);

                return precio + " €/mes";

            }


            $scope.megasTarifa = function () {

                if ($scope.cambioTarifa.datos.invoice_literal != "cero")
                    return $scope.bonoInternet($scope.cambioTarifa.datos);

                return "sin datos";

            }

            $scope.minutosTarifa = function () {

                if ($scope.cambioTarifa.voz.invoice_literal != "cero")
                    return $scope.bonoMinutos($scope.cambioTarifa.voz);

                return "0cént/min";

            }




            $scope.getTarifaVozByWebLiteral = function (literal) {

                for (var i = $rootScope.globals.bonos.voz.length - 1; i >= 0; i--) {
                    if ($rootScope.globals.bonos.voz[i].invoice_literal == literal)
                        return $rootScope.globals.bonos.voz[i]
                }
                ;

                return $rootScope.globals.bonos.voz[0];
            }

            $scope.getTarifaDatosByWebLiteral = function (literal) {

                for (var i = $rootScope.globals.bonos.datos.length - 1; i >= 0; i--) {
                    if ($rootScope.globals.bonos.datos[i].invoice_literal == literal)
                        return $rootScope.globals.bonos.datos[i]
                }
                ;

                return $rootScope.globals.bonos.datos[0];
            }

            $scope.validarCambio = function () {

                if ($scope.cambioTarifa.voz && $scope.cambioTarifa.datos)
                    return true;

                return false;
            }

            $scope.bonoPrecio = function (bono) {
                price = 0;
                if (bono.price) {
                    price = bono.price / 100;

                    price = $filter('tax')(price);

                    return price + "€";
                } else {
                    return "0€"
                }
            }

            $scope.bonoInternet = function (bono) {

                if (!bono.amount_internet)
                    return "sin datos"
                if (bono.amount_internet < 1024)
                    return bono.amount_internet + " MB";
                else
                    return Math.round((bono.amount_internet / 1024) * 10) / 10 + " GB";

            }

            $scope.bonoMinutos = function (bono) {

                if (bono.amount_minutes)
                    return bono.amount_minutes + " min";
                else
                    return "0 cént/min";

            }

            $scope.caducado = function (bonos) {
                if (!bonos.voz && !bonos.datos)
                    return true;

                return false;

            }

            $scope.activarThrottle = function () {
                var prepago = false;
                if ($rootScope.userdata.lines[$scope.globals.currentLine].line.tipo == 'pre') {
                    return;
                }


                var confirmPopup = $ionicPopup.confirm({
                    title: 'Solicitar activación de throttle',
                    template: '<p>La reducción de velocidad se le aplicará inmediatamente</p> '
                });


                confirmPopup.then(function (res) {
                    if (res) {

                        $ionicLoading.show({
                            template: 'Solicitando reducción de velocidad '
                        });

                        $scope.apiService.changeThrottle(true).then(
                                function (response)
                                {

                                    $ionicLoading.hide();



                                    $scope.showAlert(
                                            'Solicitud de reducción de velocidad confirmada',
                                            "<p>Ya puedes disfrutar de tu bono de reducción de velocidad</p>"
                                            );



                                },
                                function (err)
                                {

                                    $ionicLoading.hide();
                                    if (err.status != 403) {

                                        if (err.data.errors.children.msisdn.errors) {
                                            $scope.showAlert(
                                                    'Error solicitando activación de throttle',
                                                    err.data.errors.children.msisdn.errors
                                                    );

                                        } else {
                                            $scope.showAlert(
                                                    'Error solicitando activación de throttle',
                                                    "Ha ocurrido un error al intentar solicitar la activación de throttle"
                                                    );
                                        }


                                    }
                                }
                        );
                    }
                });
            }


            $scope.desactivarThrottle = function () {
                var prepago = false;
                if ($rootScope.userdata.lines[$scope.globals.currentLine].line.tipo == 'pre') {
                    return;
                }


                var confirmPopup = $ionicPopup.confirm({
                    title: 'Solicitar desactivación de throttle',
                    template: '<p>La reducción de velocidad se desactivará inmediatamente</p>'});



                confirmPopup.then(function (res) {
                    if (res) {

                        $ionicLoading.show({
                            template: 'Solicitando desactivación de reducción de velocidad '
                        });

                        $scope.apiService.changeThrottle(false).then(
                                function (response)
                                {

                                    $ionicLoading.hide();


                                    if (prepago) {

                                        $scope.showAlert(
                                                'Solicitud de desactivación de reducción de velocidad confirmada',
                                                "<p>El bono de bajada de velocidad se deshabilitará en 24/48H</p>"
                                                );
                                    } else {
                                        $scope.showAlert(
                                                'Solicitud de reducción de velocidad confirmada',
                                                "<p>El bono de bajada de velocidad se ha dehsabilitado</p>"
                                                );
                                    }




                                },
                                function (err)
                                {

                                    $ionicLoading.hide();
                                    if (err.status != 403) {

                                        if (err.data.errors.children.msisdn.errors) {
                                            $scope.showAlert(
                                                    'Error solicitando activación de throttle',
                                                    err.data.errors.children.msisdn.errors
                                                    );

                                        } else {
                                            $scope.showAlert(
                                                    'Error solicitando activación de throttle',
                                                    "Ha ocurrido un error al intentar solicitar la activación de throttle"
                                                    );
                                        }


                                    }
                                }
                        );
                    }
                });
            }

            $scope.precioNumericoBono = function (bono) {
                price = 0;
                if (bono.price) {
                    price = bono.price / 100;

                    price = $filter('tax')(price);

                    return price;
                } else {
                    return 0;
                }
            }


            $scope.cambiarTarifa = function () {
                var prepago = false;

                if ($rootScope.userdata.lines[$scope.globals.currentLine].line.tipo == 'pre') {
                    prepago = true;
                }

                if (prepago) {
                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Solicitar cambio de tarifa',
                        template: '<p>Estás seguro de que deseas solicitar un cambio de tarifa</p><p>El cambio de tarifa será efectivo tras finalizar los 30 días de su bono</p> '
                    });
                } else {
                    var confirmPopup = $ionicPopup.confirm({
                        title: 'Solicitar cambio de tarifa',
                        template: '<p>Estás seguro de que deseas solicitar un cambio de tarifa</p><p>El cambio de tarifa será efectivo a partir del primer día del próximo mes</p> '
                    });
                }

                confirmPopup.then(function (res) {
                    if (res) {
                        $ionicLoading.show({
                            template: 'Solicitando cambio de tarifa'
                        });

                        $scope.apiService.changeTarifa($scope.cambioTarifa).then(
                                function (response)
                                {
                                    $scope.updateSolicitudesProgramados();


                                    $ionicLoading.hide();
                                    if (prepago) {
                                        $scope.showAlert(
                                                'Solicitud de cambio de tarifa',
                                                "<p>La solicitud de cambio de tarifa ha sido realizada correctamente</p><p><strong>Recuerda: </strong>El cambio de tarifa será efectivo tras finalizar los 30 días de su bono</p>"
                                                );
                                    } else {
                                        $scope.showAlert(
                                                'Solicitud de cambio de tarifa',
                                                "<p>La solicitud de cambio de tarifa ha sido realizada correctamente</p><p><strong>Recuerda: </strong>El cambio de tarifa será efectivo a partir del primer día del próximo mes</p>"
                                                );
                                    }

                                    $ionicScrollDelegate.scrollTop(true);

                                },
                                function (err)
                                {

                                    setTimeout(function () {
                                        $ionicLoading.hide();
                                    }, 100);

                                    if (err.status != 403) {
                                        $scope.showAlert(
                                                'Error solicitando cambio de tarifa',
                                                "Ha ocurrido un error al intentar solicitar un cambio de tarifa"
                                                );
                                    }
                                }
                        );
                    }
                });
            }

            $scope.cambiarBonoDatos = function () {
                var saldo = $rootScope.userdata.lines[$scope.globals.currentLine].line.saldo;

                var precio = $scope.precioNumericoBono($scope.cambioTarifa.datos);

                $scope.data = {'action': "inm"};
                var bonos = $rootScope.userdata.lines[$scope.globals.currentLine].line.bonos;
                $scope.fechaFin = false;
                if (bonos && bonos.bonos && bonos.bonos.datos) {
                    $scope.fechaFin = bonos.bonos.datos.fecha_fin;
                }
                var myPopup = $ionicPopup.show({
                    templateUrl: 'templates/tarifa/datos.html',
                    title: 'Contratar bono de datos',
                    scope: $scope,
                    buttons: [
                        {text: 'Cancelar'},
                        {
                            text: '<b>Contratar</b>',
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.data.action) {
                                    e.preventDefault();
                                    return false;
                                } else {

                                    return $scope.data.action;
                                }
                            }
                        }
                    ]
                });
                myPopup.then(function (res) {

                    if (!res)
                        return;

                    if ($scope.data.action == "inm") {

                        if (saldo < precio) {
                            var myPopup = $ionicPopup.show({
                                templateUrl: 'templates/tarifa/no-saldo.html',
                                title: 'No tienes suficiente saldo',
                                scope: $scope,
                                buttons: [
                                    {text: 'Salir'},
                                    {
                                        text: '<b>Recargar</b>',
                                        type: 'button-positive',
                                        onTap: function (e) {

                                            return true;
                                        }
                                    }
                                ]
                            });
                            myPopup.then(function (res) {
                                if (res)
                                    $scope.recargar();
                            });
                        } else {
                            $ionicLoading.show({
                                template: 'Solicitando bono de datos'
                            });

                            $scope.apiService.contractBonoDatos($scope.cambioTarifa, $scope.data.action).then(
                                    function (response)
                                    {

                                        $scope.updateSolicitudesProgramados();

                                        $ionicLoading.hide();

                                        $scope.showAlert(
                                                'Solicitud de bono de datos correcta',
                                                "<p>La acción se ha realizado correctamente</p>"
                                                );


                                    },
                                    function (err)
                                    {

                                        $rootScope.ocultarOverlay();
                                        if (err.status != 403) {
                                            $scope.showError(
                                                    'Error solicitando bono',
                                                    "Ha ocurrido un error al intentar solicitar el bono de datos"
                                                    );
                                        }
                                    }
                            );
                        }
                    } else {
                        $scope.apiService.contractBonoDatos($scope.cambioTarifa, $scope.data.action).then(
                                function (response)
                                {

                                    $scope.updateSolicitudesProgramados();

                                    $ionicLoading.hide();

                                    $scope.showAlert(
                                            'Solicitud de bono de datos correcta',
                                            "<p>La acción se ha realizado correctamente</p><p>Por favor, recuerda que debes disponer de saldo suficiente para la activación de este bono.</p>"
                                            );


                                },
                                function (err)
                                {

                                    $rootScope.ocultarOverlay();
                                    if (err.status != 403) {
                                        $scope.showError(
                                                'Error solicitando bono',
                                                "Ha ocurrido un error al intentar solicitar el bono de datos"
                                                );
                                    }
                                }
                        );

                    }
                });






            }

            $scope.cambiarBonoVoz = function () {
                var saldo = $rootScope.userdata.lines[$scope.globals.currentLine].line.saldo;

                var precio = $scope.precioNumericoBono($scope.cambioTarifa.voz);

                $scope.data = {'action': "inm"};
                var bonos = $rootScope.userdata.lines[$scope.globals.currentLine].line.bonos;
                $scope.fechaFin = false;
                if (bonos && bonos.bonos && bonos.bonos.voz) {
                    $scope.fechaFin = bonos.bonos.voz.fecha_fin;
                }


                $scope.data = {'action': "inm"};
                var myPopup = $ionicPopup.show({
                    templateUrl: 'templates/tarifa/voz.html',
                    title: 'Contratar bono de voz',
                    scope: $scope,
                    buttons: [
                        {text: 'Cancelar'},
                        {
                            text: '<b>Contratar</b>',
                            type: 'button-positive',
                            onTap: function (e) {
                                if (!$scope.data.action) {
                                    e.preventDefault();
                                    return false;
                                } else {

                                    return $scope.data.action;
                                }
                            }
                        }
                    ]
                });
                myPopup.then(function (res) {

                    if (!res)
                        return;

                    if ($scope.data.action == "inm") {

                        if (saldo < precio) {
                            var myPopup = $ionicPopup.show({
                                templateUrl: 'templates/tarifa/no-saldo.html',
                                title: 'No tienes suficiente saldo',
                                scope: $scope,
                                buttons: [
                                    {text: 'Salir'},
                                    {
                                        text: '<b>Recargar</b>',
                                        type: 'button-positive',
                                        onTap: function (e) {

                                            return true;
                                        }
                                    }
                                ]
                            });
                            myPopup.then(function (res) {
                                if (res)
                                    $scope.recargar();
                            });
                        } else {
                            $ionicLoading.show({
                                template: 'Solicitando bono de voz'
                            });

                            $scope.apiService.contractBonoVoz($scope.cambioTarifa, $scope.data.action).then(
                                    function (response)
                                    {

                                        $scope.updateSolicitudesProgramados();

                                        $ionicLoading.hide();

                                        $scope.showAlert(
                                                'Solicitud de bono de datos correcta',
                                                "<p>La acción se ha realizado correctamente</p>"
                                                );


                                    },
                                    function (err)
                                    {

                                        $rootScope.ocultarOverlay();
                                        if (err.status != 403) {
                                            $scope.showError(
                                                    'Error solicitando bono',
                                                    "Ha ocurrido un error al intentar solicitar el bono de datos"
                                                    );
                                        }
                                    }
                            );
                        }
                    } else {
                        $ionicLoading.show({
                            template: 'Solicitando bono de voz'
                        });

                        $scope.apiService.contractBonoVoz($scope.cambioTarifa, $scope.data.action).then(
                                function (response)
                                {

                                    $scope.updateSolicitudesProgramados();

                                    $ionicLoading.hide();

                                    $scope.showAlert(
                                            'Solicitud de bono de datos correcta',
                                            "<p>La acción se ha realizado correctamente</p><p>Por favor, recuerda que debes disponer de saldo suficiente para la activación de este bono.</p>"
                                            );


                                },
                                function (err)
                                {

                                    $rootScope.ocultarOverlay();
                                    if (err.status != 403) {
                                        $scope.showError(
                                                'Error solicitando bono',
                                                "Ha ocurrido un error al intentar solicitar el bono de datos"
                                                );
                                    }
                                }
                        );
                    }
                });



                /*  var myPopup = $ionicPopup.show({
                 templateUrl: 'templates/tarifa/no-saldo.html',
                 title: 'No tienes suficiente saldo',
                 scope: $scope,
                 buttons: [
                 {text: 'Salir'},
                 {
                 text: '<b>Recargar</b>',
                 type: 'button-positive',
                 onTap: function (e) {
                 
                 return true;
                 }
                 }
                 ]
                 });
                 myPopup.then(function (res) {
                 if (res)
                 $scope.recargar();
                 });*/





            }



        })

        .controller('PionerosCtrl', function ($scope, $stateParams, ApiService, $ionicLoading, $rootScope) {

            $scope.apiService = ApiService;


            $scope.updateHistoricoPioneros = function () {

                if (typeof ($rootScope.pioneros.historico) !== 'undefined') {

                    $scope.currentHistorico = $rootScope.pioneros.historico;


                    var data = [[], []];
                    var data2 = [[]];
                    var labels = [];
                    var i = 0;
                    for (key in $scope.currentHistorico) {

                        datos = $scope.currentHistorico[key];
                        labels.push(datos.mes)
                        data[0][i] = datos.mgmh_num_hijos;
                        data[1][i] = parseInt(datos.mgmh_num_nietos) + parseInt(datos.mgmh_num_hijos);
                        data2[0][i] = datos.mgmh_importe;
                        i++;
                    }


                    $scope.colours = ['#7fbfb5', '#2F7F73'];
                    $scope.pionerosData = data;
                    $scope.pionerosBeneficioData = data2;
                    $scope.pionerosLabels = labels;
                    $scope.pionerosBeneficioLabels = labels;
                    $scope.pionerosSeries = ['Amigos', 'Total: Amigos + Amigos de Amigos'];
                    $scope.pionerosBeneficioSeries = ['Beneficio'];


                    $scope.mostrarHistorico = true;

                } else {
                    $scope.mostrarHistorico = false;
                }


            };

            $ionicLoading.show({
                template: 'Cargando plan pioneros'
            });

            $scope.apiService.getPlanPioneros().then(
                    function (response)
                    {



                        $scope.updateHistoricoPioneros();
                        $scope.data1 = [];
                        for (key in $rootScope.pioneros.amigos) {
                            amigo = $rootScope.pioneros.amigos[key];
                            $scope.data1.push(
                                    {
                                        nombre: amigo.nombre ? amigo.nombre.split(' ').slice(0, 1).join('') : "Amigo",
                                        espropio: false,
                                        esPrimero: false,
                                        hijos: amigo.nietos ? $rootScope.sizeOf(amigo.nietos) : 0,
                                        tarifa: amigo.tarifa,
                                        alta: amigo.estado_msisdn_hijo,
                                        amigos: amigo.amigos1,
                                        amigos1E: amigo.amigos1,
                                        amigos05E: amigo.amigos050,
                                        ahorras: amigo.contribuye_total

                                    }
                            )
                        }


                        setTimeout(function () {
                            $ionicLoading.hide();
                        }, 100);
                    },
                    function (err)
                    {

                        setTimeout(function () {
                            $ionicLoading.hide();
                        }, 100);

                        if (err.status != 403)
                            $scope.showAlert(
                                    'Problema de conexión',
                                    "En este momento no podemos conectar con el servidor. Revisa tu conexión y vuelve a intentarlo."
                                    );
                    }
            );



        })

        .controller('RecargasCtrl', function ($scope, $rootScope, $stateParams, ApiService, $ionicLoading, $ionicPopup) {

            $scope.apiService = ApiService;

            $scope.rechargeData = {amount: 5};

            $scope.seleccionarLineaPrepago = function () {

                if ($rootScope.userdata.lines[$scope.globals.currentLine].line.tipo != "pre") {

                    if (typeof ($rootScope.userdata) !== "undefined") {
                        for (var key in $rootScope.userdata.lines) {
                            if ($rootScope.userdata.lines[key].line && $rootScope.userdata.lines[key].line.tipo == "pre")
                                $scope.globals.currentLine = key;
                            break;

                        }
                    }
                }

            };

            $scope.recargar = function () {



                var confirmPopup = $ionicPopup.confirm({
                    title: 'Solicitar recarga ',
                    template: '<p>Estás seguro de que deseas realizar una recarga</p><p>Esta operación te sacara a una ventana externa</p> '
                });

                confirmPopup.then(function (res) {
                    if (res) {
                        $ionicLoading.show({
                            template: 'Solicitando recarga '
                        });

                        $scope.apiService.requestRecharge($scope.rechargeData.amount).then(
                                function (response)
                                {

                                    url = response.data.url;

                                    $ionicLoading.hide();
                                    window.open(url, '_blank', 'location=yes');


                                },
                                function (err)
                                {

                                    setTimeout(function () {
                                        $ionicLoading.hide();
                                    }, 100);

                                    if (err.status != 403) {
                                        $scope.showAlert(
                                                'Error solicitando recarga ',
                                                "Ha ocurrido un error al intentar solicitar una recarga"
                                                );
                                    }
                                }
                        );
                    }
                });
            }
            $scope.seleccionarLineaPrepago();


        })

        .controller('FacturasCtrl', function ($scope, $rootScope, $stateParams, ApiService, $ionicLoading, $cordovaFileOpener2) {

            $scope.total = function (elem) {
                var total = parseFloat(elem.imp_total_antes_impuestos) + parseFloat(elem.facturas[factura].imp_iva);

                return total;
            }




            $scope.apiService = ApiService;
            $ionicLoading.show({
                template: 'Cargando facturas'
            });
            $scope.finish = false;
            $scope.apiService.getFacturas().then(
                    function (response)
                    {


                        $scope.labels = [];
                        $scope.values = [];
                        for (value in $rootScope.graficaFacturas) {
                            console.log(value);

                            $scope.labels.push($rootScope.graficaFacturas[value].mes_string);
                            $scope.values.push($rootScope.graficaFacturas[value].total);

                        }

                        $scope.series = ['Ultimas facturas'];
                        $scope.data = [
                            $scope.values
                        ];
                        $scope.colours = ["#7fbfb5"];

                        console.log($scope.values);
                        $scope.finish = true;
                        setTimeout(function () {
                            $ionicLoading.hide();
                        }, 100);
                    },
                    function (err)
                    {

                        setTimeout(function () {
                            $ionicLoading.hide();
                        }, 100);

                        if (err.status != 403)
                            $scope.showAlert(
                                    'Problema de conexión',
                                    "En este momento no podemos conectar con el servidor. Revisa tu conexión y vuelve a intentarlo."
                                    );
                    }
            );


        });
