var directives = angular.module('app.directives', []);

directives.directive("bankAccount", function(ValidationService){
  // requires an isloated model
  return {
   // restrict to an attribute type.
   restrict: 'A',
  // element must have ng-model attribute.
   require: 'ngModel',
   link: function(scope, ele, attrs, ctrl){

      // add a parser that will process each time the value is
      // parsed into the model when the user updates it.
      ctrl.$parsers.unshift(function(value) {
        if(value){
          // test and set the validity after update.

         var valid=ValidationService.validaCuentaBancaria(value);
        
          ctrl.$setValidity('invalidBankAccount', valid);
        }

        // if it's valid, return the value to the model,
        // otherwise return undefined.
        return valid ? value : undefined;
      });

   }
  }
})
directives.directive('arbor', function() {
    return{
        restrict: 'A',
        scope: {graphData1: '=data'},
        link: function(scope, elem, attrs) {
            scope.$watch("graphData1", function(v) {

            if(typeof(v)!= "undefined"){
                    

                    hijos=v;

                  // Initialise arbor
                  //sys.parameters({stiffness:600, repulsion:2000, gravity:false, dt:0.015});
                  sys = arbor.ParticleSystem(1000, 600, 0.5) // create the system with sensible repulsion/stiffness/friction
                  sys.renderer = RendererCanvasPioneros("#viewport") // our newly created renderer will have its .init() method called shortly by sys...
                  sys.renderer._initMouseHandling(); 


                  nombre="YO";
                  sys.addNode(nombre, { init: true, title: "YO", w: 50 });
                  sys.addNode('fake', { fake: true });
                  sys.addEdge(nombre,'fake');
                  $('.info-amigo').hide();
                  var missingNodeCreated = false;
                  var missingGrands = 0;
                  var missingGrands1E = 0;
                  var missingGrands05E = 0;

                  for (i in hijos)
                  {
                      if(hijos[i].alta != 'B'){
                          sys.addNode(i, { hijo: true, title: hijos[i].nombre.toLowerCase(), alta: true, espropio: hijos[i].espropio, esprimero: hijos[i].esprimero, hijos: hijos[i].hijos, tarifa: hijos[i].tarifa, amigos1E: hijos[i].amigos1E, amigos05E: hijos[i].amigos05E, w: 30, ahorras: hijos[i].ahorras });
                          sys.addEdge(nombre, i);
                      } else {
                          missingGrands1E = missingGrands1E + parseInt(hijos[i].amigos1E);
                          missingGrands05E = missingGrands05E + parseInt(hijos[i].amigos05E);
                      }
                      
                      if (hijos[i].hijos != undefined)
                      {
                          for (j=0;j<hijos[i].hijos; j++)
                          {
                              if(hijos[i].alta != 'B'){
                                  sys.addNode(i+'-'+j, { nieto: true, w: 10 });
                                  sys.addEdge(i, i+'-'+j);
                              }
                          }
                      }
                  }
                  if(missingGrands1E + missingGrands05E > 0){
                      sys.addNode('B', { hijo: true, title: 'Baja', alta: false, amigos1E: missingGrands1E, amigos05E: missingGrands05E, w: 30, ahorras: missingGrands05E/2 + missingGrands1E });
                      sys.addEdge(nombre, 'B');
                      for (var i = 0; i < missingGrands1E + missingGrands05E; i++) {
                          sys.addNode('B-'+i, { nieto: true, w: 10 });
                          sys.addEdge('B','B-'+i);
                      };
                  }
                }

            });
        }
    };
});;