var filters = angular.module('app.filters', []);

filters.filter('orderObjectBy', function(){
 return function(input, attribute,asc) {
    if (!angular.isObject(input)) return input;

    var array = [];
    for(var objectKey in input) {
		if(objectKey>0)
			array.push(input[objectKey]);
    }

    array.sort(function(a, b){
        a = parseInt(a[attribute]);
        b = parseInt(b[attribute]);
        return a - b;
    });

    if(!asc)
        array.reverse();


    return array;
 }
})
.filter('removeHour', function(){
 return function(value) {
    if(value)
        return value = value.substring(0, value.indexOf(' '));
    
    return value;
    }
})

.filter('bonoType', function(){
 return function(value) {
    if(value=="thr"){
        return "";
    }
    
    if(value=="dat"){
        return "datos"
    }
    
     if(value=="voz"){
        return "voz"
    }
    
    return "";
    }
})
.filter('capitalize', function(){
 return function(value) {
    if(value)
        return value.charAt(0).toUpperCase() + value.slice(1).toLowerCase();
    
    return value;
    }
})

.filter('lowercase', function(){
 return function(value) {
    if(value)
        return value.toLowerCase();
    
    return value;
    }
})
.filter('round', function(){
 return function(value) {
       if(value)
        return Math.round(value);

        return value;
 }
})
.filter('tax', function($rootScope){
 return function(value) {
        var tax=1.21;

        if($rootScope.userdata.client.tax)
            tax=$rootScope.userdata.client.tax;

        if (!value)
            return value;

        newPrice=value*tax;

        return parseFloat(Math.round(newPrice * 10) / 10).toFixed(2);
 }
})
.filter('tax2', function($rootScope){
 return function(value,aplicarImpuesto) {
    console.log(aplicarImpuesto);
    if(!aplicarImpuesto)
        return value;

        var tax=1.21;

        if($rootScope.userdata.client.tax)
            tax=$rootScope.userdata.client.tax;

        if (!value)
            return value;

        newPrice=value*tax;

        return parseFloat(Math.round(newPrice * 100) / 100).toFixed(2);
 }
});
