var baseurl = 'https://www.republicamovil.es/es/api/v2';
angular.module('starter.services', [])

        .factory('AuthenticationService',
                ['Base64', '$http', '$localStorage', '$rootScope', '$timeout',
                    function (Base64, $http, $localStorage, $rootScope, $timeout) {
                        var service = {};

                        service.Login = function (username, password, callback) {

                            $http.post(baseurl + '/login', {'username': username, 'password': password})
                                    .success(
                                            function (data)
                                            {
                                                $http.defaults.headers.common['apikey'] = username + ';' + data.apiKey;
                                                $localStorage.set('apikey', username + ';' + data.apiKey);
                                                $localStorage.set('username', username);
                                                $localStorage.set('isLogged', true);
                                                $http.get(baseurl + '/me')
                                                        .success(
                                                                function (data)
                                                                {
                                                                    $rootScope.userdata = data;

                                                                    for (number in $rootScope.userdata.lines)
                                                                        $rootScope.globals.currentLine = number;
                                                                    callback(data);
                                                                })
                                                        .error(
                                                                function (data)
                                                                {

                                                                    callback(false);
                                                                }
                                                        );
                                            })
                                    .error(
                                            function (data)
                                            {
                                                callback(false);
                                            }
                                    );
                        };

                        service.ResetPassword = function (username, callback) {

                            $http.get(baseurl + '/reset-password?username=' + username)
                                    .success(
                                            function (data)
                                            {

                                                callback({result: true, data: data});
                                            })
                                    .error(
                                            function (data)
                                            {

                                                callback({result: false, data: data});
                                            }
                                    );

                        };

                        service.Impersonate = function (username, password, impersonate, callback) {

                            $http.post(baseurl + '/impersonar', {'username': username, 'password': password, 'impersonate': impersonate})
                                    .success(
                                            function (data)
                                            {
                                                $http.defaults.headers.common['apikey'] = impersonate + ';' + data.apiKey;
                                                $localStorage.set('apikey', impersonate + ';' + data.apiKey);
                                                $localStorage.set('username', impersonate);
                                                $localStorage.set('isLogged', true);
                                                $http.get(baseurl + '/me')
                                                        .success(
                                                                function (data)
                                                                {
                                                                    $rootScope.userdata = data;

                                                                    for (number in $rootScope.userdata.lines)
                                                                        $rootScope.globals.currentLine = number;
                                                                    callback(data);
                                                                })
                                                        .error(
                                                                function (data)
                                                                {

                                                                    callback(false);
                                                                }
                                                        );
                                            })
                                    .error(
                                            function (data)
                                            {
                                                callback(false);
                                            }
                                    );
                        };

                        service.checkLogin = function (callback) {


                            $http.get(baseurl + '/me')
                                    .success(
                                            function (data)
                                            {
                                                $rootScope.userdata = data;

                                                for (number in $rootScope.userdata.lines)
                                                    $rootScope.globals.currentLine = number;

                                                callback(data);
                                            })
                                    .error(
                                            function (data)
                                            {
                                                callback(false);
                                            }
                                    );

                        };

                        service.ClearCredentials = function () {
                            $rootScope.globals = {};
                            $cookieStore.remove('globals');
                            $http.defaults.headers.common.Authorization = 'Basic ';
                        };

                        return service;
                    }]
                )
        .factory('ApiService',
                ['$http', '$cookieStore', '$rootScope', '$timeout', '$cordovaFileTransfer', '$localStorage',
                    function ($http, $cookieStore, $rootScope, $timeout, $cordovaFileTransfer, $localStorage) {
                        var service = {};

                        service.getPlanPioneros = function () {

                            return $http.get(baseurl + '/me/pioneros')
                                    .success(
                                            function (data)
                                            {
                                                $rootScope.pioneros = data;
                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.getConsumo = function () {

                            return $http.get(baseurl + '/me/consumo')
                                    .success(
                                            function (data)
                                            {
                                                $rootScope.consumo = data;
                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.getConsumoLinea = function (msisdn) {

                            return $http.get(baseurl + '/me/consumo/' + msisdn)
                                    .success(
                                            function (data)
                                            {
                                                $rootScope.consumo[msisdn] = data;
                                                $rootScope.consumo[msisdn].finalizado = true;
                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.getFacturas = function () {

                            return $http.get(baseurl + '/me/facturas')
                                    .success(
                                            function (data)
                                            {

                                                $rootScope.facturas = data.facturas;
                                                $rootScope.graficaFacturas = data.grafica;
                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.getContrato = function (msisdn) {

                            var url = baseurl + '/me/contrato/' + msisdn + "?apiKey=" + $localStorage.get('apikey');
                            var isAndroid = ionic.Platform.isAndroid();
                            if (isAndroid)
                                var targetPath = cordova.file.externalDataDirectory.replace('file://', '') + msisdn + ".pdf";
                            else
                                var targetPath = cordova.file.documentsDirectory + msisdn + ".pdf";
                            var trustHosts = true
                            var headers = {'apikey': $localStorage.get('apikey')};
                            var options = {};
                            options.headers = headers;

                            return $cordovaFileTransfer.download(url, targetPath, options, trustHosts);



                        };

                        service.getContratoUrl = function (msisdn) {

                            var url = baseurl + '/me/contrato/' + msisdn + "?apiKey=" + $localStorage.get('apikey');

                            return url;



                        };

                        service.changePersonalData = function (personalData) {

                            var formData = {
                                'firstName': personalData.firstName,
                                'email': personalData.email,
                                'identityType': personalData.identityType,
                                'identityValue': personalData.identityValue,
                                'birthday': personalData.birthday,
                                'nationality': personalData.nationality.id,
                                'streetName': personalData.streetName,
                                'postcode': personalData.postcode,
                                'locality': personalData.locality,
                                'postalTown': personalData.postalTown.id
                            };

                            return $http.post(baseurl + '/me/datos/facturacion', formData)
                                    .success(
                                            function (data)
                                            {

                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.changeContactData = function (contactData) {

                            var formData = {
                                'name': contactData.name,
                                'email': contactData.email,
                                'contactPhone': contactData.phone
                            };

                            return $http.post(baseurl + '/me/datos/contacto', formData)
                                    .success(
                                            function (data)
                                            {

                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.changeTarifa = function (datosTarifa) {

                            var formData = {
                                'msisdn': $rootScope.globals.currentLine,
                                'bonoVoz': datosTarifa.voz.web_literal,
                                'bonoDatos': datosTarifa.datos.web_literal,
                                'bonoThrottle': datosTarifa.throttle,
                                'bonoVoip': false,
                            };

                            return $http.post(baseurl + '/me/tarifa', formData)
                                    .success(
                                            function (data)
                                            {

                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };
                        
                        service.changeThrottle = function (action) {

                                var formData={
                                    'msisdn': $rootScope.globals.currentLine,
                                    'bonoThrottle': action
                                };

                                return $http.post(baseurl+'/me/throttle',formData)
                                    .success(
                                    function(data)
                                    {

                                    })
                                    .error(
                                    function(data)
                                    {

                                    }
                                );
                        };
                        
                        service.contractBonoVoz = function(datosTarifa,action) {

                                var formData={
                                    'msisdn': $rootScope.globals.currentLine,
                                       'bonoVoz':datosTarifa.voz.web_literal,
                                       'action': action,
                                   };

                               return $http.post(baseurl+'/me/bono/contratar/voz',formData)
                                   .success(
                                   function(data)
                                   {

                                   })
                                   .error(
                                   function(data)
                                   {

                                   }
                               );
                           };

                           service.contractBonoDatos = function(datosTarifa,action) {

                                var formData={
                                       'msisdn': $rootScope.globals.currentLine,
                                       'bonoDatos':datosTarifa.datos.web_literal,
                                       'bonoThrottle':datosTarifa.throttle,
                                       'action': action,
                                   };

                               return $http.post(baseurl+'/me/bono/contratar/datos',formData)
                                   .success(
                                   function(data)
                                   {

                                   })
                                   .error(
                                   function(data)
                                   {

                                   }
                               );
                           };

                        service.detalleTarifa = function (msisdn) {



                            return $http.get(baseurl + '/me/tarifa/' + msisdn)
                                    .success(
                                            function (data)
                                            {

                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };


                        service.changePassword = function (newPassword) {

                            return $http.post(baseurl + '/me/password', {'password': newPassword})
                                    .success(
                                            function (data)
                                            {

                                                var username = $localStorage.get('username');
                                                var apikey = username + ';' + data.apiKey;

                                                $localStorage.set('apikey', apikey);
                                                $http.defaults.headers.common['apikey'] = apikey;


                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.changeBankAccount = function (bankAccount) {

                            var formData = {
                                'titular': bankAccount.titular,
                                'bankAccount': bankAccount.cuenta,
                                'identityType': bankAccount.identityType,
                                'identityValue': bankAccount.identityValue,
                            };



                            return $http.post(baseurl + '/me/datos/bancarios', formData)
                                    .success(
                                            function (data)
                                            {



                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.requestRecharge = function (recharge) {

                            var formData = {
                                'amount': recharge
                            };


                            return $http.post(baseurl + '/me/line/' + $rootScope.globals.currentLine + '/recarga', formData)
                                    .success(
                                            function (data)
                                            {


                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.getNacionalidades = function () {

                            return $http.get(baseurl + '/nationalities')
                                    .success(
                                            function (data)
                                            {

                                                $rootScope.globals.nacionalidades = data;


                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.getProvincias = function () {

                            return $http.get(baseurl + '/provinces')
                                    .success(
                                            function (data)
                                            {

                                                $rootScope.globals.provincias = data;


                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };

                        service.getBonos = function () {

                            return $http.get(baseurl + '/bonos')
                                    .success(
                                            function (data)
                                            {

                                                $rootScope.globals.bonos = data;


                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );

                        };




                        service.changeService = function (msisdn, service, action) {

                            return $http.post(baseurl + '/me/line/' + msisdn + "/" + service + "/" + action)
                                    .success(
                                            function (data)
                                            {


                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );



                        };

                        service.contractBono = function (msisdn) {

                            return $http.post(baseurl + '/me/bono/' + msisdn)
                                    .success(
                                            function (data)
                                            {


                                            })
                                    .error(
                                            function (data)
                                            {

                                            }
                                    );



                        };

                        service.getFactura = function (year, month, accountId) {

                            var url = baseurl + '/me/facturas/' + year + "/" + month + "?apiKey=" + $localStorage.get('apikey') + "&accountId=" + accountId;


                            var isAndroid = ionic.Platform.isAndroid();
                            if (isAndroid)
                                var targetPath = cordova.file.externalDataDirectory.replace('file://', '') + year + month + ".pdf";
                            else
                                var targetPath = cordova.file.documentsDirectory + year + month + ".pdf";
                            var trustHosts = true
                            var headers = {'apikey': $localStorage.get('apikey')};
                            var options = {};
                            options.headers = headers;

                            return $cordovaFileTransfer.download(url, targetPath, options, trustHosts);



                        };

                        service.getFacturaUrl = function (year, month, accountId) {

                            var url = baseurl + '/me/facturas/' + year + "/" + month + "?apiKey=" + $localStorage.get('apikey') + "&accountId=" + accountId;

                            return url;



                        };




                        return service;
                    }]
                )
        .factory('$localStorage', ['$window', function ($window) {
                return {
                    set: function (key, value) {
                        $window.localStorage[key] = value;
                    },
                    get: function (key, defaultValue) {
                        return $window.localStorage[key] || defaultValue;
                    },
                    remove: function (key) {
                        return $window.localStorage.removeItem(key);
                    },
                    setObject: function (key, value) {
                        $window.localStorage[key] = JSON.stringify(value);
                    },
                    getObject: function (key) {
                        return JSON.parse($window.localStorage[key] || '{}');
                    }
                }
            }])
        .factory('Base64', function () {
            /* jshint ignore:start */

            var keyStr = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';

            return {
                encode: function (input) {
                    var output = "";
                    var chr1, chr2, chr3 = "";
                    var enc1, enc2, enc3, enc4 = "";
                    var i = 0;

                    do {
                        chr1 = input.charCodeAt(i++);
                        chr2 = input.charCodeAt(i++);
                        chr3 = input.charCodeAt(i++);

                        enc1 = chr1 >> 2;
                        enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                        enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                        enc4 = chr3 & 63;

                        if (isNaN(chr2)) {
                            enc3 = enc4 = 64;
                        } else if (isNaN(chr3)) {
                            enc4 = 64;
                        }

                        output = output +
                                keyStr.charAt(enc1) +
                                keyStr.charAt(enc2) +
                                keyStr.charAt(enc3) +
                                keyStr.charAt(enc4);
                        chr1 = chr2 = chr3 = "";
                        enc1 = enc2 = enc3 = enc4 = "";
                    } while (i < input.length);

                    return output;
                },
                decode: function (input) {
                    var output = "";
                    var chr1, chr2, chr3 = "";
                    var enc1, enc2, enc3, enc4 = "";
                    var i = 0;

                    // remove all characters that are not A-Z, a-z, 0-9, +, /, or =
                    var base64test = /[^A-Za-z0-9\+\/\=]/g;
                    if (base64test.exec(input)) {
                        window.alert("There were invalid base64 characters in the input text.\n" +
                                "Valid base64 characters are A-Z, a-z, 0-9, '+', '/',and '='\n" +
                                "Expect errors in decoding.");
                    }
                    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

                    do {
                        enc1 = keyStr.indexOf(input.charAt(i++));
                        enc2 = keyStr.indexOf(input.charAt(i++));
                        enc3 = keyStr.indexOf(input.charAt(i++));
                        enc4 = keyStr.indexOf(input.charAt(i++));

                        chr1 = (enc1 << 2) | (enc2 >> 4);
                        chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                        chr3 = ((enc3 & 3) << 6) | enc4;

                        output = output + String.fromCharCode(chr1);

                        if (enc3 != 64) {
                            output = output + String.fromCharCode(chr2);
                        }
                        if (enc4 != 64) {
                            output = output + String.fromCharCode(chr3);
                        }

                        chr1 = chr2 = chr3 = "";
                        enc1 = enc2 = enc3 = enc4 = "";

                    } while (i < input.length);

                    return output;
                }
            };

            /* jshint ignore:end */
        })

        .factory('myHttpInterceptor', function ($q, $location, $localStorage, $injector) {
            return {
                request: function (config) {
                    if (navigator.connection) {
                        var url = config.url;
                        if (url.indexOf("http") != -1) {
                            var type = navigator.connection.type;
                            if (typeof Connection != 'undefined')
                            {
                                if (type == Connection.UNKNOWN || type == Connection.NONE) {
                                    alert("Por favor, comprueba tu conexión a internet");
                                }
                            }
                        }
                    }

                    return config;
                },
                responseError: function (response) {
                    /*if (typeof response.config != 'undefined')
                     LE.error("Ajax Error CODE: " + response.status + " | url: " + response.config.url + " | response: " + response.statusText);
                     
                     if (typeof response.message != 'undefined')
                     LE.error("JS error: " + response.message);*/

                    if (response.status === 403 && response.config.url.indexOf("login") == -1) {

                        $localStorage.remove("token");
                        $localStorage.remove("isLogged");
                        $localStorage.remove("username");

                        $injector.get('$ionicLoading').hide();
                        $injector.get('$state').transitionTo('home');

                        $localStorage.remove('isLogged');
                        $localStorage.remove('username');
                        $localStorage.remove('apikey');
                        var alertPopup = $injector.get('$ionicPopup').alert({
                            title: 'Error de Autenticación',
                            template: 'Por favor,vuelva a introducir tus credenciales'
                        });
                    }
                    return $q.reject(response); // not a recoverable error
                }
            }
        })
        .factory('$voip', function ($q, $http) {
            return {
                request: function (config) {
                    return config;
                },
                activate_line: function (phoneLine) {
                    return $q(function (resolve, reject) {
                        cordova.exec(
                                function () {
                                    resolve();
                                },
                                function (err) {
                                    reject(err);
                                },
                                "MediaRefresh",
                                "voipToken",
                                [phoneLine]
                                );
                    });
                },
                check: function () {
                    return $q(function (resolve, reject) {
                        cordova.exec(
                                function (result) {
                                    resolve(result.phone);
                                },
                                function (err) {
                                    reject(err);
                                },
                                "MediaRefresh",
                                "hasVoip",
                                []
                                );
                    });
                },
                getLines: function () {
                    return $q(function (resolve, reject) {
                        $http.get(baseurl + '/voip/check_user')
                                .success(
                                        function (data)
                                        {
                                            resolve(data);
                                        })
                                .error(
                                        function (data)
                                        {
                                            reject(data);
                                        }
                                );
                    });
                },
                deactivate: function (number) {
                    return $http.delete(baseurl + '/voip/delete_user/' + number);
                }
            }
        })
        .factory('ValidationService', function () {
            return {
                validaCuentaBancaria: function (bankAccount) {



                    if (bankAccount.length != 20)
                        return false

                    var entidad = bankAccount.substring(0, 4);
                    var oficina = bankAccount.substring(4, 8);
                    var digito = bankAccount.substring(8, 10);
                    var cuenta = bankAccount.substring(10, 20);


                    return this.validaLibreta(entidad, oficina, digito, cuenta)
                },
                validaLibreta: function (i_entidad, i_oficina, i_digito, i_cuenta) {
                    // VALIDACIÓN DE CUALQUIER LIBRETA DE CUALQUIER ENTIDAD BANCARIA.
                    // Funcion recibe como parámetro la entidad, la oficina, 
                    // el digito (concatenación del de control entidad-oficina y del de control entidad)
                    // y la cuenta. Espera los valores con 0's a la izquierda.
                    // Devuelve true o false.
                    // NOTAS:
                    // Formato deseado de los parámetros:
                    // - i_entidad (4)
                    // - i_oficina (4)
                    // - i_digito (2)
                    // - i_cuenta (10)


                    var wtotal, wcociente, wresto;
                    if (i_entidad.length != 4) {
                        return false;
                    }
                    if (i_oficina.length != 4) {
                        return false;
                    }
                    if (i_digito.length != 2) {
                        return false;
                    }
                    if (i_cuenta.length != 10) {
                        return false;
                    }
                    wtotal = i_entidad.charAt(0) * 4;
                    wtotal += i_entidad.charAt(1) * 8;
                    wtotal += i_entidad.charAt(2) * 5;
                    wtotal += i_entidad.charAt(3) * 10;
                    wtotal += i_oficina.charAt(0) * 9;
                    wtotal += i_oficina.charAt(1) * 7;
                    wtotal += i_oficina.charAt(2) * 3;
                    wtotal += i_oficina.charAt(3) * 6;
                    // busco el resto de dividir wtotal entre 11
                    wcociente = Math.floor(wtotal / 11);
                    wresto = wtotal - (wcociente * 11);
                    //
                    wtotal = 11 - wresto;
                    if (wtotal == 11) {
                        wtotal = 0;
                    }
                    if (wtotal == 10) {
                        wtotal = 1;
                    }
                    if (wtotal != i_digito.charAt(0)) {
                        return false;
                    }
                    //hemos validado la entidad y oficina
                    //-----------------------------------
                    wtotal = i_cuenta.charAt(0) * 1;
                    wtotal += i_cuenta.charAt(1) * 2;
                    wtotal += i_cuenta.charAt(2) * 4;
                    wtotal += i_cuenta.charAt(3) * 8;
                    wtotal += i_cuenta.charAt(4) * 5;
                    wtotal += i_cuenta.charAt(5) * 10;
                    wtotal += i_cuenta.charAt(6) * 9;
                    wtotal += i_cuenta.charAt(7) * 7;
                    wtotal += i_cuenta.charAt(8) * 3;
                    wtotal += i_cuenta.charAt(9) * 6;

                    // busco el resto de dividir wtotal entre 11
                    wcociente = Math.floor(wtotal / 11);
                    wresto = wtotal - (wcociente * 11);
                    //
                    wtotal = 11 - wresto;
                    if (wtotal == 11) {
                        wtotal = 0;
                    }
                    if (wtotal == 10) {
                        wtotal = 1;
                    }

                    if (wtotal != i_digito.charAt(1)) {
                        //alert(wtotal+' y no '+i_digito.charAt(1));
                        return false;
                    }
                    // hemos validado la cuenta corriente

                    return true;
                }


            }
        });
