(function(){

RendererCanvasPioneros = function(canvas){
        var _canvas = $(canvas);
        _canvas.attr('width', _canvas.parent().width());
        _canvas.attr('height', _canvas.parent().height());
        
        var canvas = $(canvas).get(0)
        var ctx = canvas.getContext("2d");
        var particleSystem;
    
        
        var that = {
          
          init:function(system){
            particleSystem = system
            particleSystem.screenSize(canvas.width, canvas.height) 
            particleSystem.screenPadding(80)
          },
          
          _initMouseHandling:function(){
            nearest = null;
            var handler = {
              moved:function(e){
                var pos = $(canvas).offset();
                _mouseP = arbor.Point(e.pageX-pos.left, e.pageY-pos.top)
                nearest = sys.nearest(_mouseP);
    
                if (!nearest.node) return false; 
                
                if (nearest.distance <15 && nearest.node.data.amigos1E != undefined)
                {
                    $('.info-amigo').show();
                    $('.info-amigo').css({ left: nearest.screenPoint.x+nearest.node.data.w+46, top: nearest.screenPoint.y - nearest.node.data.w - 15 });
                    $('.info-nombre-amigo').html(nearest.node.data.title);
		    if (nearest.node.data.alta)
                    	$('.info-tarifa-amigo').html(nearest.node.data.tarifa);
		    else
			$('.info-tarifa-amigo').html("");
                    $('.info-amigos-amigo').html('tiene <span>'+nearest.node.data.amigos1E+'</span> amigos de 1€<br> y <span>'+nearest.node.data.amigos05E+'</span> de 0,50€');
                    $('.info-ahorro-amigo span').html(nearest.node.data.title);
                    $('.info-euros-amigo span').html(nearest.node.data.ahorras);
                }
                else
                    $('.info-amigo').hide();
                    
                return false;
              }
            }
            $(canvas).mousemove(handler.moved);
    
          },
          
          redraw:function(){
            ctx.fillStyle = "white"
            ctx.fillRect(0,0, canvas.width, canvas.height)
            
            particleSystem.eachEdge(function(edge, pt1, pt2){
              if (edge.target.name != 'fake')
              {
                  ctx.strokeStyle = "rgba(0,0,0, .333)"
                  ctx.lineWidth = 1
                  ctx.beginPath()
                  ctx.moveTo(pt1.x, pt1.y)
                  ctx.lineTo(pt2.x, pt2.y)
                  ctx.stroke()
              }
            })
    
            particleSystem.eachNode(function(node, pt){
              if (node.data.fake === undefined)
              {
                  if (node.data.init !== undefined || node.data.espropio)
                  {
		    if (node.data.init)
                    	var w = 50;
		    else
			var w = 30;
                    ctx.fillStyle = "rgb(0,0,0)";
                  }
                  else if (node.data.nieto !== undefined)
                  {
                    var w = 10;
                    ctx.fillStyle = "rgb(51, 51, 51)";
                  }
                  else if (!node.data.alta){
                    var w = 30;
                    ctx.fillStyle = "rgb(127, 191, 181)";
                  }
                  else
                  {
                    var w = 30;
                    ctx.fillStyle = "rgb(127, 191, 181)";
                  }
                    
                  ctx.beginPath();
                  ctx.arc(pt.x, pt.y, w, 0, Math.PI*2, true); 
                  ctx.closePath();
                  ctx.fill();
                  ctx.fillStyle = "rgb(255,255,255)";
                  
                  ctx.font = '10pt \'Open Sans\'';
                  ctx.textAlign = 'center';
                  ctx.fillStyle = 'white';
                  
                  if (node.data.title != undefined)
                  {
                    var texto = node.data.title;
                    if (texto.length > 8)
                        ctx.font = '8pt \'Open Sans\'';
                    if (texto.length > 11)
                        ctx.font = '6pt \'Open Sans\'';

                    ctx.fillText(texto, pt.x, pt.y+5);
                  }
                }
            }) 			
          }
        }
        return that;
 }    
})()
